#!/bin/sh
#interfaz Xdialog para arrancar flrec, grabar desde mesa mezclas y
# guardar el output en el ordenata como ogg/mp3/wav (PARA CUAS)
#Utiliza flrec/sox para la grabacion (flrec-cunyas hack),
# di para el uso del disco, bc para calcular el espacio en disco,
# y vorbiscomment|id3v2 para meter comentarios en el ogg|mp3.
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal):
#DIRKUNYAS=/home/martintxo/pruebas
DIRKUNYAS=/home/garraxi/Biltegi/Kunyas/kunyas
DIRTEMP=/tmp
#DIPATH=/
DIPATH=/home/garraxi/Biltegi/Kunyas

#Variable que guarda informacion sobre espacio libre en disco:
# Con df problema: segun baja el tamao disponible, cambia el output de df y cut puede no encontrar el valor
# solucion: utilizar di (pero hace honor a LANG y da decimales separados por comas, y eso no gusta a bc)
DISCO="`export LANG=en; di -f v -n -m -w 0 $DIPATH; export LANG=es_ES`"

#Con la tasa de bits a la que grabamos con flrec/sox (90 kb/s) una hora ocupa aprox 30 Mb.
#Por lo que en sdc1 (8.624Mb) pueden llegar a caber unas 280 horas de cuas.
HORAS=$(echo "scale=1; $DISCO/30" | bc)

#GUI para dar el nombre del archivo donde se graba:
GUI=`Xdialog --wmclass "grabar" --title "Grabar CUAS" \
        --backtitle "En el disco duro donde se guardan las cuas (sdc1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacin." \
	--stdout --left --separator "|" \
	--inputbox "Escribe un nombre descriptivo para la CUA.\n * Ejemplo: Manifa_presos-5_feb_2006\n * Utiliza un nombre sencillo, con pocas palabras, y sin letras raras ( \"'s\" ), NI ESPACIOS.\n * El archivo se guarda en ~/Biltegi/Kunyas/kunyas/.\n    NO LO MUEVAS DE AH (es la carpeta desde la que se emiten automticamente).\n * Si crees que hay poco espacio para grabar cuas (lo dice aqu arriba)\n    avisa a l*s admins (en la asamblea o en garraxi@sindominio.net).\n         -------------------\n * Tras dar al OK te aparecer la ventana del programa grabador.\n * Haz click en el botn pequeo que hay encima del que tiene un crculo rojo.\n * Despus haz click en el botn del crculo rojo y EMPEZAR A GRABAR.\n         -------------------\n * Cuando acabes de grabar haz click en el botn del cuadrado verde (finaliza la grabacin).\n * Despus cierra el programa con la \"x\" de arriba a la derecha.\n * Aparecer una ventana informativa similar a esta, sigue sus instrucciones.\nGracias :-D!!." 0 0 "" `

#Cuando NO se rellena la casilla, sale sin decir nada (igual si se cancela, o se quita con el boton "x" del windowmanager):
if [ "$GUI" = "" ];then
  exit;
fi

#Cuando el fichero que queremos grabar ya existe de antes, da mensaje de error y arranca de nuevo el programa:
# OOPS: no permite guardar 2 cuas con el mismo nombre, aunque les cambiemos de extension.
if [ -f "$DIRKUNYAS/$GUI.ogg" ] || [ -f "$DIRKUNYAS/$GUI.mp3" ] || [ -f "$DIRKUNYAS/$GUI.wav" ];then
 Xdialog --wmclass "grabar" --title "Grabar CUAS" \
	--infobox "OOOPS!!\nEl nombre de la cua que has elegido ya existe.\nIntentalo de nuevo con otro nombre." 0 0 5000;
 exec flrec-grabacunya.sh;
fi

#Cuando SI se rellena la casilla, arranca el flrec-cunyas con las opciones adecuadas, listo para grabar:
#Graba la cua en dir /tmp para que no exista durante su grabacion y asi un Somad arrancado no pueda
# comenzar a emitir la cua que se esta grabando en ese momento.
#Esto solo era imp. para programas, pero implementado tb. para cuas porsia :-D.
if [ "$GUI" != "" ];then
  #Variable para meter la fecha de la cua en los comentarios del ogg/mp3:
  DATE=`date +%d/%m/%Y_%H:%M:%S`;
  flrec-cunyas -q "$DIRTEMP/$GUI.ogg";
  FORMAT=`file --mime --brief "$DIRTEMP/$GUI.ogg"`

  if [ "$FORMAT" = "application/ogg" ]; then
   vorbiscomment -a -t "TITLE=Cunya \"$GUI\", grabada el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -t "ARTIST=Realizador@s de \"$GUI\"" -t "DATE=$DATE" -t "COPYRIGHT=Las personas que han grabado la cunya \"$GUI\"" -t "LICENSE=Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-NoComercial-CompartirIgual\": http://creativecommons.org/licenses/by-nc-sa/2.5/es/" -t "ORGANIZATION=Garraxi Irratia" -t "CONTACT=http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI.ogg"
   EXT="ogg"  
  elif [ "$FORMAT" = "audio/mpeg" ]; then
   id3v2 -t "Cunya \"$GUI\", grabada el `echo "$DATE" | cut --delimiter="_" -f 1 -s`" -a "Realizador@s de \"$GUI\"" --TDAT "$DATE" -y `echo "$DATE" | cut --delimiter="_" -f 1 -s | cut --delimiter="/" -f 3 -s` --WCOP "Las personas que han grabado la cunya \"$GUI\"" -c "Se permite la copia, modificacin y distribucin de esta obra bajo los trminos de la licencia de Creative Commons \"Reconocimiento-NoComercial-CompartirIgual\"." --TPUB "Garraxi Irratia" --WPUB "http://www.sindominio.net/garraxi/" "$DIRTEMP/$GUI.ogg"
   EXT="mp3"
  elif [ "$FORMAT" = "audio/x-wav" ]; then
   EXT="wav"
  else
   EXT="formato.desconocido"
  fi
  
   #Al finalizar la grabacion, mueve el archivo grabado al lugar adecuado:   
   mv "$DIRTEMP/$GUI.ogg" "$DIRKUNYAS/$GUI.$EXT";
 #GUI con la info final:
   Xdialog --wmclass "soma" --title "Grabar CUAS" --ok-label "FIN" --left  --timeout 20 \
        --msgbox "          BIEEEN :-D!!.\nHas terminado de grabar la cua y ha quedado guardada en:\n    "$DIRKUNYAS/$GUI.$EXT"\nAhora, si quieres que esa cua est disponible para su emisin,\n   haz doble click sobre el cono de abajo a la izquierda del escritorio\n   que sirve para que Somad relea los archivos que tiene para emitir y se entere de los cambios.\nSi hubiera algn problema comntalo en la asamblea, o en garraxi@sindominio.net.\nGracias :-D!!" 0 0;

 exit $?

fi
