#!/bin/sh
#script para anunciar las reemisiones de programas.
#Utiliza ircha+mbrola | festival, grep, gawk, cut, vorbiscomment, id2v2, tee y mplayer.
#El script es para todos los programas, y el nombre del archivo de programa (nombre_programa.ext)
# lo pilla de la invocacion del comando y lo reproduce con text-to-speech (ircha+mbrola o festival).
#
#PROBLEMA: Hay delay entre las invocaciones de mplayer y las del text-to-speech.
# entonces a veces queda un pequeo silencio antes y despues del nombre del programa y de la fecha.
# La longitud del silencio depende de lo cacheado que este el programa en memoria (o algo).
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

NOMBREPROG=$*  #Es: nombre_programa.ext
#DIRPROGRAMAS=/home/martintxo/pruebas
DIRPROGRAMAS=/home/garraxi/Biltegi/Programas
#DIRJINGLES=/home/martintxo/pruebas
DIRJINGLES=/home/garraxi/Biltegi/Kunyas/jingles

#Si el archivo del programa a emitir no existe, o si existe pero tiene tamao 0 bytes, exit:
if  [ ! -f "$DIRPROGRAMAS/$NOMBREPROG" ] || [ ! -s "$DIRPROGRAMAS/$NOMBREPROG" ] ;then
 exit
fi

#Quita extension a $NOMBREPROG
NOMBREPROG2=`echo "$NOMBREPROG" | gawk '{ sub (/.[oO][gG][gG]/, ""); sub (/.[mM][pP]3/, ""); print }'`

#Preprocesa $NOMBREPROG2 para meter espacios (se entiende mejor con palabras separadas) y punto final:
if  echo "$NOMBREPROG2" | grep '_' > /dev/null ;then
 #Conversion de "_" a "espacio"
 NOMBREPROG3=`echo "$NOMBREPROG2." | tr "_" " "`
else
 #Conversion de "mayuscula" a "espacio+mayuscula":
 NOMBREPROG3=`echo "$NOMBREPROG2." | gawk '{ gsub (/[[:upper:]]/, " &"); print }'`
fi

#Parseo de la fecha de grabacion del programa:
#Si ogg, busca fecha del programa en comentarios de vorbis y la formatea en $FECHA:
if [ "`echo "$NOMBREPROG" | grep -i '.ogg'`" ] && [ "`vorbiscomment -l "$DIRPROGRAMAS/$NOMBREPROG" | grep -i "date"`" ] ;then
 VORBISDATE=`vorbiscomment -l "$DIRPROGRAMAS/$NOMBREPROG" | grep -i "date" | cut -d "=" -f 2 -s | cut -d "_" -f 1 -s`
 VDIA=`echo "$VORBISDATE" | cut -d "/" -f 1 -s`
 VMES=`echo "$VORBISDATE" | cut -d "/" -f 2 -s`
 VAO=`echo "$VORBISDATE" | cut -d "/" -f 3 -s`
 FECHA=`export LANG=es_ES && date --date="$VAO""$VMES""$VDIA" +"%e de %B del %Y."`
#Si mp3, busca la fecha en los id3 tags:
elif [ "`echo "$NOMBREPROG" | grep -i '.mp3'`" ] && [ "`id3v2 -l "$DIRPROGRAMAS/$NOMBREPROG" | grep -i "date"`" ] ;then
 MP3DATE=`id3v2 -l "$DIRPROGRAMAS/$NOMBREPROG" | grep -i "date" | cut -d " " -f 3 -s | cut -d "_" -f 1 -s`
 MDIA=`echo "$MP3DATE" | cut -d "/" -f 1 -s`
 MMES=`echo "$MP3DATE" | cut -d "/" -f 2 -s`
 MAO=`echo "$MP3DATE" | cut -d "/" -f 3 -s`
 FECHA=`export LANG=es_ES && date --date="$MAO""$MMES""$MDIA" +"%e de %B del %Y."`
else
#En otro caso lee la fecha del programa de la fecha de modificacion del archivo (menos fiable):
 OTHERDATE=`stat -c %y "$DIRPROGRAMAS/$NOMBREPROG" | cut --delimiter=" " -f 1 -s`
 ODIA=`echo "$OTHERDATE" | cut -d "-" -f 3 -s`
 OMES=`echo "$OTHERDATE" | cut -d "-" -f 2 -s`
 OAO=`echo "$OTHERDATE" | cut -d "-" -f 1 -s`
 FECHA=`export LANG=es_ES && date --date="$OAO""$OMES""$ODIA" +"%e de %B del %Y."`
fi

#Info de que va a tocar, a stadout y a soma.log:
echo "Play: /jingle-reemisiones.ogg + /$NOMBREPROG" | tee -a /var/log/soma/soma.log

############### Rutina de emision continua (no meter calculos dentro):

#Reproduce archivo de sonido con contenido "Hola querido oyente ...":
mplayer -msglevel avsync=5 -ao alsa,oss, -af volnorm -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRJINGLES/jingle-reemisiones1.ogg"

#Lee en voz alta el nombre del programa (ejemp: "Saltsa Berde."):
lee "$NOMBREPROG3" 2> /dev/null
#echo `echo "$NOMBREPROG3"` | festival --tts --language spanish

#Reproduce archivo de sonido con texto "...que fue emitido el dia...":
mplayer -msglevel avsync=5 -ao alsa,oss, -af volnorm -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRJINGLES/jingle-reemisiones2.ogg"

#Lee en voz alta la fecha del programa:
lee "$FECHA"  2> /dev/null
#echo  "$FECHA" | festival --tts --language spanish

#Cortinilla final "Garraxi Irratia 101.9":
mplayer -msglevel avsync=5 -ao alsa,oss, -af volnorm -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRJINGLES/jingle-reemisiones3.ogg"

#Reemision del programa:
mplayer -msglevel avsync=5 -ao alsa,oss, -af volnorm -novideo -noconsolecontrols -nojoystick -nolirc -nomouseinput "$DIRPROGRAMAS/$NOMBREPROG"

exit
